import React from 'react';
import style from './index.less';
import chronicPic from "../../common/images/chronic.png";
import level1 from "../../common/images/级别1.png";
import tableIcon from '@common/images/table.png';
import allTableIcon from '@common/images/all-table.png';
import add from '@common/images/add-result.png';
import added from '@common/images/first.png';
import checkIcon from '@common/images/check.png';
import up from '@common/images/slide-up.png';
import down from '@common/images/slide-down.png';
import {ComplexModal,ConfirmModal,MiniToast, Radio,CheckBtn,Footer,Notify} from '@commonComp';
import infoShow from '@common/images/info-show.png';
import infoMove from '@common/images/info-move.png';
import ScaleTable from '@containers/ScaleTable';
import {deepClone} from '@utils/tools';
import $ from 'jquery';
import config from '@config/index';

/***
慢病右侧推送模块规则:
慢病--显示慢病名称以及管理和评估
普通病--不显示管理和评估和量表按钮
明细--量表-计算公式-核心指标
controlType:0-radio  1-checkbox  2-text  3-dropdownlist
**/

class ChronicInfo extends React.Component{
  constructor(props){
    super(props);
    this.state = {
      show:true,
      showInfo:false,
      showOption:false,
      showAssess:false,      //评估弹窗
      infoId:null,  //静态知识
      formulaId:null, //计算公式
      optionId:null,  //可能结果,
      isAssessConfirm:false,    //是否点击评估弹窗确定按钮
      radioVal:{},  //可能结果选择内容
      possible:{},  //可能结果
      formulaParam: {}, //量表计算公式计算入参
      isCalculated:false,     //是否刚计算过，关闭时值与结果对应
      calcuValues:deepClone(props.calcuValues),       //计算公式填的值
      hasEnterImg: false, //是否移入info
      currentIndex: -1 //当前index
    };

    this.$content = React.createRef();
    this.showInfo = this.showInfo.bind(this);
    this.closeInfo = this.closeInfo.bind(this);
    this.showOption = this.showOption.bind(this);
    this.closeOption = this.closeOption.bind(this);
    this.showTable = this.showTable.bind(this);//显示量表弹窗
    this.closeTable = this.closeTable.bind(this);//关闭量表弹窗
    this.close = this.close.bind(this); //关闭量表列表
    this.showFormula = this.showFormula.bind(this); //打开计算公式
    //this.closeFormula = this.closeFormula.bind(this); //关闭计算公式
    this.handleAddAssessItem = this.handleAddAssessItem.bind(this);   //加入病例记录
    this.onPrint = this.onPrint.bind(this);
    this.handleForRadio = this.handleForRadio.bind(this);
    this.handleSaveCalcu = this.handleSaveCalcu.bind(this);     //保存评估修改的计算和可能结果
    this.getAddBtnState = this.getAddBtnState.bind(this);
    this.slideToggle = this.slideToggle.bind(this);
  }

  onPrint() {
    const {showHide} = this.props;
    let dom = showHide&&showHide.showTable?$("#printcontent"):$("#AssistResult");
    dom.jqprint({
      debug: false,
      importCSS: true,
      printContainer: true,
      operaSupport: false,
    });
  }
  
  showTableList(name){//量表按钮
    const {getTableList} = this.props;
    if(name){
      getTableList(name);
    }
  }
  close(){//关闭量表列表
    const {hideList} = this.props;
    hideList&&hideList({name:'showList',value:false});
  }
  handleListClick(item){//量表列表单项点击
    this.showTable(item,null);
    //this.close()
  }

  showInfo(item){
    // 静态知识显示在提示信息里（4-18）
    const {getInfomation} = this.props;
    const param = {
      id:item.id,
      name: item.name,
      // id:40738, //目前只有“肾功能不全”有数据
      type:22,
      position: 1
    }
    getInfomation&&getInfomation(param);
  }
  closeInfo(){//关闭静态知识
    this.setState({
      infoId:null
    })
  }
  showOption(id){
    this.setState({
      optionId:id,
      formulaId:null //关闭计算公式
    })
  }
  closeOption(){
    // 关闭-有可能结果则保持与结果一致，没有就保持最新选择的内容
    let {possible,radioVal} = this.state;
    if(JSON.stringify(possible)=='{}'){
      this.setState({
        optionId:null
      })
    }else{
      this.setState({
        radioVal:Object.assign({},radioVal,possible),
        optionId:null,
      });
    }
  }
  showTable(it){
    const {scaleInfo} = this.props;
    // 密西根糖尿病周围神经病评分（MDNS）, id:40744
    const item = {
      id:it.conceptId,
      name:it.name
    };
    // 判断：store里已经有该量表就无需重新调接口
    if(scaleInfo&&scaleInfo[it.conceptId]){
      this.props.hideList({name:'showTable',value:true},it);
    }else{
      this.props.getScaleInfo(item);
    }

    this.setState({
      formulaId:null, //关闭计算公式和可能结果弹窗
      optionId:null
    })
  }
  closeTable(){
    this.props.hideList({name:'showTable',value:false});
  }
  showFormula(id){//计算公式
    this.setState({
      formulaId:id,
      optionId:null  //关闭可能结果
    })
  }
  closeFormula(it){
    const {formulaId,isCalculated} =this.state;
    if(!isCalculated){
      //没有计算结果时，保存输入的值
      const {calcuResult,calcuValues} = this.props;
      const cres = calcuResult&&calcuResult[formulaId]||it.content.result;
      const result = cres&&cres[1]&&cres[1].text;
      if(result){
        this.setState({
          calcuValues:deepClone(calcuValues)
        });
      }
    }
    this.setState({
      formulaId:null,
    });
  }
  handleAddAssessItem(v,pIndex,i){
    const {addAssessItem} = this.props;
    addAssessItem(v,pIndex,i);
  }
  handleReg(e){   //只能输入数字
    const hasDot = e.target.value.indexOf('.')!=-1;
    const key = e.key;
    if(key!='Backspace'&&((/[^\d]/.test(key)&&key!='.')||(key=='.'&&(hasDot||!e.target.value)))){
      e.preventDefault();
    }
  }
  handleInputformula(id,calcuContent,i,e) {
    const {calcuValues} = this.state;
    let obj = deepClone(calcuValues);
    let values = (obj&&obj[id])||deepClone(calcuContent);
    const txt = e.target.value;
    values[i].value = txt.replace(/[\u4e00-\u9fa5]|[^\d|.]/g,'');       //处理中文输入法的情况
    obj[id] = values;
    if(/[\u4e00-\u9fa5]|[^\d|.]/g.test(txt)){
      e.target.value = txt.replace(/[\u4e00-\u9fa5]|[^\d|.]/g,'');
    }
    this.setState({
      isCalculated:false,
      calcuValues:obj
    });
  }
  handleForRadio(id,calcuContent,i,fidx){//计算公式
    const { calcuValues } = this.state;
    let obj = deepClone(calcuValues);
    let values = (obj&&obj[id])||deepClone(calcuContent);
    let details = values[i].details;
    for(let x=0;x<details.length;x++){
      if(x!=fidx){
        details[x].state=0;
      }else{
        details[x].state=1;
      }
    }
    obj[id] = values;
    this.setState({
      isCalculated:false,
      calcuValues:obj
    });
  }
  handleRadio(item,parent){//可能结果
    let {radioVal} = this.props;
    this.setState({
      radioVal:Object.assign({},radioVal,{[parent.conceptId]:item.detailName})
    })
  }
  confirmOption(parent,pIndex){//可能结果确定
    const {radioVal,possible} = this.state;
    const {savePossibleResult} = this.props;
    this.setState({
      possible:Object.assign({},possible,radioVal),
      radioVal:Object.assign({},possible,radioVal),//不设置radioVal只有最近一次选中的值
      optionId:null,
    });
    savePossibleResult&&savePossibleResult({possible:Object.assign({},possible,radioVal),radioVal:Object.assign({},possible,radioVal)})
  }
  handleSaveCalcu(obj){
    this.setState({
      possible:Object.assign({},obj.possible),
      radioVal:Object.assign({},obj.radioVal),//不设置radioVal只有最近一次选中的值
    })
  }
  calcuFormula(id,it) { //计算公式计算
    const { calcuFormula } = this.props;
    let item = deepClone(it);
    const values = this.state.calcuValues;
    const calcuValues = Object.keys(values).length&&values[id]?values[id]:item.content.details;
    let allHasInfo = true;
    for (let i = 0; i < calcuValues.length; i++) {
      if(calcuValues[i].controlType == 2) {  //输入框类型的有没有填值
        if(!calcuValues[i].value) {
          allHasInfo = false;
        }
      } else if(calcuValues[i].controlType == 1) {
        let hasSelect = false;
        for( let z = 0; z <calcuValues[i].details.length; z++) {
          if(calcuValues[i].details[z].state == 1) {
            hasSelect= true;
          }
        }
        if(!hasSelect) {
          allHasInfo = false;
        }
      }
    }
    item.content.details = calcuValues;
    if(allHasInfo) { //所有都有值，则计算
      let param = {
        type: 2,
        data: item,
        disId: id
      };
      calcuFormula(param);
      this.setState({
        isCalculated:true
      });
    } else {  //不是所有值都填过了
      Notify.info('请填写计算公式内容')
    }
  }
  getAddBtnState(flag,v,i,j){
    const {indexs,wholeScaleItems,addScaleItems,chronicMagItem,chronicDesease,addedScaleIds} = this.props;
    let btn = '',reCheck=false;
    let show = chronicMagItem&&chronicMagItem.name||chronicDesease&&chronicDesease.name;
    if(!show){
      return '';
    }
    if(flag){     //有结果
      if(j!==undefined){
        reCheck = addedScaleIds.includes(v.details[j].content.id);      //列表中是否加入同一量表
        btn = (indexs[i]&&indexs[i].includes(j))||reCheck?<span className={style["add-record"]}>
                   <img src={added} />
                   已加入
                 </span>:<span className={style["listResult"]} onClick={()=>this.handleAddAssessItem(v,i,j)}>
                   <img src={add} />
                   加入病历记录
                 </span>;
      }else{
        reCheck = addedScaleIds.includes(v.id);         //推送中是否加入同一量表
        btn = (wholeScaleItems&&wholeScaleItems[i])||reCheck?<span className={style["add-record"]}>
                   <img src={added} />
                   已加入
                 </span>:<span className={style["listResult"]} onClick={()=>addScaleItems(v,i)}>
                   <img src={add} />
                   加入病历记录
                 </span>;
      }

    }else{
      btn = <span className={style["disable-add"]}>
                   <img src={add} />
                   加入病历记录
                 </span>;
    }

    return btn;
  }
  handleMouseEnterDrug(index) {
    this.setState({
        currentIndex: index,
    })
  }
  handleMouseLeaveDrug() {
    this.setState({
        currentIndex: -1,
    })
  }
  handleMouseEnterImg() {
    this.setState({
      hasEnterImg: true
    })
  }
  handleMouseLeaveImg() {
    this.setState({
      hasEnterImg: false
    })
  }
  getDetail(){
    const {data,formulaResult,calcuResult,indexs} = this.props;
    const {formulaId,optionId,possible,radioVal,calcuValues,currentIndex,hasEnterImg} = this.state;
    let list = data&&data.map((v,i)=>{
                    return <div className={style["list"]}>
                      {v.name?<p>
                                <span>患者可能有</span>
                                <span
                                  className={style['dis-name']}
                                  onMouseEnter={this.handleMouseEnterDrug.bind(this, i)}
                                  onMouseLeave = {this.handleMouseLeaveDrug.bind(this)}
                                >
                                  {v.name}
                                  {<img className={style['info-img']}
                                    style ={currentIndex === i  ? {display: "inline-block"} : {display: "none"}}
                                    src={currentIndex === i ?(hasEnterImg ? infoMove : infoShow ): infoShow}
                                    onMouseEnter={this.handleMouseEnterImg.bind(this)}
                                    onMouseLeave = {this.handleMouseLeaveImg.bind(this)}
                                    onClick={this.showInfo.bind(this,v)}/>}

                                </span>
                                {/* <img src={infoShow} className={style["infoPic"]} onClick={this.showInfo.bind(this,v.id)}/> */}

                                ：
                              </p>:''}
                      {/*<MiniToast title='静态知识'
                                icon={allTableIcon}
                                show={infoId&&infoId==v.id?true:false}
                                close={this.closeInfo}>
                          {pureText}
                      </MiniToast>*/}
                      {v.details&&v.details.map((it,j)=>{
                        if(it.type==1){
                          return <p>
                                <span className={style["listName"]}>
                                  <i onClick={this.showTable.bind(this,it.content,v.conceptId,i)}>{'【'+it.content.name+'】'}</i>
                                  {formulaResult&&formulaResult[it.content.conceptId]?<i>{'结果：'}{formulaResult[it.content.conceptId].calcalculate&&formulaResult[it.content.conceptId].calcalculate.result.value +' '+ formulaResult[it.content.conceptId].calcalculate.result.text}</i>:''}
                                </span>
                                {
                                  this.getAddBtnState(formulaResult&&formulaResult[it.content.conceptId],v,i,j)
                                }
                              </p>
                        }else if(it.type==2){
                          const cres = calcuResult&&calcuResult[v.conceptId]||it.content.result;
                          const result = cres&&cres[1]&&cres[1].text;
                          const details = calcuValues&&calcuValues[v.conceptId]||it.content.details;
                          return <div className={style["marTop"]}>
                            <span className={style["limit"]}>
                              计算公式结果：
                              <i className={style["blue"]} onClick={this.showFormula.bind(this,v.conceptId)}>{result?result:'请选择'}</i>
                              <img src={level1} />
                            </span>
                            {
                              this.getAddBtnState(result,v,i,j)
                            }
                            {formulaId&&formulaId==v.conceptId&&<MiniToast title={it.content.name}
                                icon={allTableIcon}
                                confirmText='关闭'
                                show={formulaId&&formulaId==v.conceptId?true:false}
                                close={this.closeFormula.bind(this,it)}
                                confirm={this.closeFormula.bind(this,it)}
                                footer="true">
                                <table>
                                {details.map((item,idd)=>{
                                    if(item.controlType==0){//单选
                                      return <tr>
                                        <td>
                                          <span>{'请选择'+item.name+'：'}</span>
                                        </td>
                                        <td>
                                          {Array.isArray(item.details)&&item.details.map((ii,ind)=>{
                                            return <div className={style["chooseItem"]}>
                                                    <Radio label={ii.detailName}
                                                             isSelect={ii.state == 1}
                                                             handleClick={this.handleForRadio.bind(this,v.conceptId,details,idd,ind)}>
                                                      </Radio>
                                                  </div>
                                          })}
                                        </td>  
                                      </tr>
                                    }else if(item.controlType==2){//输入框
                                      return <tr>
                                        <td>
                                          <span>{'请输入'+item.name+'：'}</span>
                                        </td>
                                        <td>
                                          <input type="text" placeholder="请输入"  value={item.value} onKeyDown={this.handleReg.bind(this)} onInput={this.handleInputformula.bind(this,v.conceptId,details,idd)}/>
                                        </td>
                                        <td>
                                          <span>{item.uint}</span>
                                        </td>

                                      </tr>
                                    }
                                })}
                                </table>
                                <div className={style["forMulBtn"]} onClick={this.calcuFormula.bind(this,v.conceptId,it)}>计算</div>
                                <table>
                                  {cres && Array.isArray(cres) &&cres.map((itemResult, resultIndex) => {
                                    return <tr>
                                        <td>
                                            <span>{itemResult.name+'：'}</span>
                                        </td>
                                        <td>
                                            <span>{itemResult.text}</span>
                                        </td>
                                    </tr>
                                  })}
                                </table>
                                
                            </MiniToast>}
                          </div>
                        }else if(it.type==3){
                          return <div className={style["marTop"]}>
                            <span className={style["limit"]}>
                              可能结果：
                              <i onClick={this.showOption.bind(this,v.conceptId)} className={style["blue"]}>{possible[v.conceptId]?possible[v.conceptId]:'请选择'}</i>
                              <img src={level1} />
                            </span>
                            {
                              this.getAddBtnState(possible[v.conceptId],v,i,j)
                            }
                            <MiniToast title='结果选择'
                                icon={checkIcon}
                                show={optionId&&optionId==v.conceptId?true:false}
                                close={this.closeOption}
                                confirm={this.confirmOption.bind(this,v,i)}
                                footer="true">
                                <div className={style["infoOption"]}>
                                  <span>{it.content.name?it.content.name+'：':''}</span>
                                  {it.content.details&&it.content.details.map((lis,ind)=>{
                                    return <div className={style["chooseItem"]}>
                                      <Radio label={lis.detailName}
                                               isSelect={radioVal[v.conceptId]==lis.detailName}
                                               handleClick={this.handleRadio.bind(this,lis,v)}>
                                        </Radio>
                                        {lis.state==1?<span className={style['recomand']}>（智能推荐）</span>:''}
                                    </div>
                                  })}
                                </div>
                            </MiniToast>
                          </div>
                        }
                      })}
                    </div>
                  })
    return list;
  }
  componentWillReceiveProps(next){
    if(JSON.stringify(next.calcuValues)!=JSON.stringify(this.props.calcuValues)){
      this.setState({
        calcuValues:next.calcuValues
      })
    }
    if(next.slideUp!=this.props.slideUp){
      if(next.slideUp){
        $(this.$content.current).slideUp(config.slideTime);
      }else{
        $(this.$content.current).slideDown(config.slideTime);
      }
    }
  }
  slideToggle(){
    const {toggleSlide,slideUp} = this.props;
    toggleSlide&&toggleSlide(!slideUp);
  }
  render(){
    const scaleFooter = <Footer print={true}
                                footText="确定"
                                handlePrint={this.onPrint}
                                handleConfirm={this.closeTable}/>;
    const {chronicMagItem,tableList,chronicDesease,formulaResult,showHide,slideUp} = this.props;
    return <div className={style["tips"]} style={{marginBottom:'15px'}}>
              <div className={`${style["tips-title"]} ${style["chronic"]}`}>
                <div className={style["tips-name"]}>
                  <img src={chronicPic} />
                  <h2>{chronicMagItem&&chronicMagItem.name||chronicDesease&&chronicDesease.name||'病情提示'}</h2>
                  <span className={style["redTips"]}>(页面信息有更新可能影响评估结果)</span>
                </div>
                <div className={style['toggle-btn']}>
                  <img src={slideUp?down:up} alt="展开/收起" onClick={this.slideToggle}/>
                </div>
                {/*<div className={style["tips-btn"]} style={{display:chronicMagItem&&chronicMagItem.name||chronicDesease&&chronicDesease.name?'block':'none'}}>
                  <span className={style["tipsDetails"]} onClick={() => this.showTableList(chronicDesease&&chronicDesease.name||chronicMagItem&&chronicMagItem.name)}>量表
                  </span>
                </div>*/}
              </div>
              <div className={style["content"]} ref={this.$content}>
                  {this.getDetail()}
              </div>
              {/*<ConfirmModal visible={showHide&&showHide.showList} noFooter='true' title='全部量表' close={this.close} titleBg="#DFEAFE" icon={allTableIcon} height={450} width={450}>
                      <ul className={style['toast-cont']}>
                        {tableList&&tableList.map((v,i)=>{
                          return <li>
                            <span className={style["scaleName"]}>
                              <i onClick={this.handleListClick.bind(this,v)}>{'【'+v.name+'】'}</i>
                              {formulaResult&&formulaResult[v.conceptId]?<i className={style['res']}>{'结果：'}{formulaResult[v.conceptId].calcalculate&&formulaResult[v.conceptId].calcalculate.result.value+' '+ (formulaResult[v.conceptId].calcalculate.result.text?formulaResult[v.conceptId].calcalculate.result.text:'')}</i>:''}
                            </span>
                            {
                              this.getAddBtnState(formulaResult&&formulaResult[v.conceptId],v,i)
                            }
                          </li>
                        })}
                      </ul>
              </ConfirmModal>*/}
              {showHide&&showHide.showTable?<ComplexModal onclose={this.closeTable} footer={scaleFooter}
                      title={showHide.name}
                      icon={tableIcon}
                      top={20}
                      bottom={20}
                      width={820}>
                <ScaleTable title={showHide.name} tableId={showHide.id}></ScaleTable>
              </ComplexModal>:''}
      </div>
  }
}
export default ChronicInfo;