import { get, post, json } from "@utils/ajax";
import { BILLING_ADVICE, SET_TIPS, SET_TIPS_DETAILS ,SET_CHRONIC_TABLELIST,SET_SCALE_INFO,SET_CHRONIC_PUSHS,SHOW_TABLE_LIST, SHOW_TIPS_DETAILS,TOGGLE_CHRONIC_INFO} from '@store/types/pushMessage';
import { SET_DRUG_INFO, SHOW_DRUG_INFO } from '@store/types/treat';
import { SET_CLICK_DIAG } from '../types/diagnosticList';
import {storageLocal,getEMRParams} from '@utils/tools';
import {SET_IMPORT_CHECKBODY_LABEL,PRESET} from "../types/checkBody";
import { Notify} from '@commonComp';
import {pregetCheckbodyData} from '@store/async-actions/fetchModules';
const api={
  push:'/push/pushInner',
  getTableList:'/scale/getList', //获取量表列表
  getTableInfo:'/scale/getContent', //获取量表明细
  getConceptDetail:'/conceptDetail/getConceptDetail', //获取静态提示信息
}

//获取右侧推送信息
export const billing = (mdata,boxMark) => {
 return (dispatch, getState) =>{
  const state = getState();
  let url = api.push;
   const checkBody = state.checkBody.data;
   let getCheck = boxMark==2&&!(checkBody&&checkBody.length>0&&!checkBody[0].full);
  const emrData = getEMRParams();
  const params = {
    age: emrData.age,
    featureType: getCheck?"4,5,6,7":"5,6,7",
    // featureType: "22",
    diag: emrData.dis,
    lis: emrData.lis,
    other: emrData.other,
    pacs: emrData.pacs,
    sex: emrData.sex,
    vital:emrData.vital,
    symptom: mdata?(emrData.current + mdata):(emrData.current + emrData.main),
    hosCode: emrData.hosCode
  };
  let savePm = Object.assign({},params);
   delete savePm.featureType;
  storageLocal.set('emrParam',savePm);      //推送数据存储，用作推送前对比是否有变，有变才推送
    json(url, params).then((data) => {
        let {dis, lab, pacs,markedVitalIds,moduleVital} = data.data.data||{};
        lab = lab||[];
        pacs = pacs||[];
        // console.log('推送数据', data.data.data);
        let vigilant=[], //警惕
             doubt=[],    //疑似诊断
            possible = [],  //可能诊断
            determine=[]; //确诊
            doubt = dis&&dis['疑似诊断'],
            possible = dis&&dis['可能诊断'];
            vigilant = dis&&dis['警惕'];
            determine = dis&&dis['确诊']; //确诊
        if(lab) {
            for(let i = 0; i < lab.length; i++) {
                lab[i].checked = false
            }
        }
        if(pacs) {
            for(let i = 0; i < pacs.length; i++) {
                pacs[i].checked = false
            }
        }

        dispatch({
          type:TOGGLE_CHRONIC_INFO,
          flag:false
        });
        dispatch({
            type: BILLING_ADVICE,
            determine: determine || [],
            doubt: doubt||[],
            possible: possible||[],
            vigilant: vigilant||[],
            lab: lab||[],
            pacs: pacs||[],
        });
        dispatch({
          type:PRESET,
          data:moduleVital
        });
        //查体高亮标签
        dispatch({
          type:SET_IMPORT_CHECKBODY_LABEL,
          labels:markedVitalIds
        })
  }).catch((e) =>{
      console.log(e)
  });
   //单独调指标
   const ps = Object.assign({},params,{featureType:'22'});
   json(url, ps).then((data) => {
     let {medicalIndications} = data.data.data||{};

     //慢病推送模块数据
     dispatch({
       type:SET_CHRONIC_PUSHS,
       data:medicalIndications
     });
   }).catch((e) =>{
     console.log(e)
   });

   //调查体,现病史触发推送且查体无数据时获取查体模板
   /*const checkBody = state.checkBody.data;
   if(boxMark==2&&!(checkBody&&checkBody.length>0&&!checkBody[0].full)){
     dispatch(pregetCheckbodyData());
   }*/
 }
};

//获取提示信息（静态信息）
export const getConceptDetail = (item) => {
    return(dispatch, getState) => {

        const params ={
            name: item.name,
            position: item.position,
            type: item.type
        }

        json(api.getConceptDetail, params).then((res) => {
            if(res.data.code == '0') {
                if(item.position == '1') {  //右侧提示信息
                    dispatch({
                        type: SET_CLICK_DIAG,
                        clickDiag: item
                    })
                    if(item.type == '5' || item.type == '6') {
                        dispatch({
                            type: SET_TIPS,
                            tips: res.data.data,
                            tmpFlg:'midPart'
                        })
                    } else {
                        dispatch({
                            type: SET_TIPS,
                            tips: res.data.data,
                        });
                        dispatch({
                          type:TOGGLE_CHRONIC_INFO,
                          flag:true
                        });
                    }
                    
                } else if(item.position == '5' || item.position == '6'){    //药品或不良反应说明
                    dispatch({
                        type: SET_DRUG_INFO,
                        instroduce: res.data.data.details,
                        name: item.name,
                        tagType: item.type
                    })
                    dispatch({
                        type: SHOW_DRUG_INFO
                    })
                }
            } else {
                Notify.info('提示信息未维护')
            }
            
        })
    }
}

export const getAllConceptDetail = (item) => {
    return(dispatch, getState) => {
        const state = getState();
        const params = {
            type: item.type,
            name: item.name,
            position:item.position
        }
        json(api.getConceptDetail, params)
        .then((res)=>{
            if(res.data.code == '0') {
                dispatch({
                    type: SHOW_TIPS_DETAILS
                })
                dispatch({
                    type: SET_TIPS_DETAILS,
                    tipsDetails: res.data.data
                })
            } else {
                Notify.info('提示信息未维护')
            }
                
        }).catch((e) => {
            console.log(e)
        })
    }
}

// 量表列表
export const getTableList = (name)=>{
    return (dispatch,getState)=>{
        json(api.getTableList, {disName:name})
        .then((res)=>{
            if(res.data.code==0 && res.data.data && res.data.data.length>0){
                dispatch({
                    type: SET_CHRONIC_TABLELIST,
                    data: res.data.data
                })
                dispatch({
                    type:SHOW_TABLE_LIST,
                    name:'showList',
                    value:true
                })
            }else{
                Notify.info(res.data.msg||'无关联量表')
            }
        }).catch((e) => {
            console.log(e)
        })
    }
}

// 量表明细
export const getScaleInfo = (it)=>{
    return (dispatch,getState)=>{
        const emrData = getEMRParams();
          const params = {
            age: emrData.age,
            sex: emrData.sex,
            featureType: "21",
            diag: emrData.dis,
            lis: emrData.lis,
            scaleId:it.id,
            scaleName:it.name,
            other: emrData.other,
            pacs: emrData.pacs,
            vital:emrData.vital,
            symptom: emrData.current + emrData.main,
            // indications:'' //指标结果
          };
        // json(api.push, params)
        json(api.getTableInfo, params)
        .then((res)=>{
            const result = res.data;
            // if(result.code==0 && result.data.scale && result.data.scale.length>0){
            if(result.code==0 && result.data.length>0){
                dispatch({
                    type: SET_SCALE_INFO,
                    // data: result.data.scale,
                    data: result.data,
                    id:it.id
                })
                dispatch({
                    type:SHOW_TABLE_LIST,
                    name:'showTable',
                    value:true,
                    item:Object.assign({},it)
                })
            }else{
                Notify.info(result.msg||'暂无量表信息')
            }
        }).catch((e) => {
            console.log(e)
        })
    }
}